/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/
#include "ai8051u.h"
#include "usart2.h"
#include "ai_usb_ex.h"
#include "string.h"

BOOL Uart2TxBusy;

BYTE Uart2RxRptr;
BYTE Uart2RxWptr;

BYTE Uart2TxRptr;
BYTE Uart2TxWptr;

BYTE xdata Uart2RxBuffer[256];
BYTE xdata Uart2TxBuffer[256];

LINECODING LineCoding;

//========================================================================
// : SetTimer2Baudraye(u32 dat)
// : Timer2ʷ
// : dat: Timer2װֵ.
// : none.
// 汾: VER1.0
// : 2025-04-07
// ע: 
//========================================================================
void SetTimer2Baudraye(u32 dat)
{
    T2R = 0;		//Timer stop
    T2_CT = 0;	//Timer2 set As Timer
    T2x12 = 1;	//Timer2 set as 1T mode
    T2H = (u8)(dat / 256);
    T2L = (u8)(dat % 256);
    ET2 = 0;    //ֹж
    T2R = 1;		//Timer run enable
}

void uart2_init()
{
		SetTimer2Baudraye(115200);
		S2CFG |= 0x01;     //ʹô2ʱW1λΪ1ܻԤڵĴ
		
    S2CON = 0x50;
    PS2 = 1;    //ߴ2жȼֹݶʧ
		S2REN = 1;         //
    ES2 = 1;
		S2_S = 1;       //UART2(RxD2_2/P4.2, TxD2_2/P4.3)
	

    LineCoding.dwDTERate = REV4(115200);
    LineCoding.bCharFormat = 0;
    LineCoding.bParityType = 0;
    LineCoding.bDataBits = 8;
    
    Uart2TxBusy = 0;
    Uart2RxRptr = 0;
    Uart2RxWptr = 0;
    Uart2TxRptr = 0;
    Uart2TxWptr = 0;
}


void uart2_isr() interrupt UART2_VECTOR
{
    if (S2TI)
    {
        S2TI = 0;
        Uart2TxBusy = 0;
    }

    if (S2RI)
    {
				P01 = ~P01;
        S2RI = 0;
        Uart2TxBuffer[Uart2TxWptr++] = S2BUF;
    }
}

void uart_setting(BYTE index){
		LineCoding.bCharFormat = 0;
    LineCoding.bDataBits = 8;
		if(index == 0){
			uart_set_parity();
			uart_set_baud();
		}
}
void uart_set_parity()
{
   	 switch (LineCoding.bParityType)
			{
			default:
			case NONE_PARITY:
					S2CON = 0x50;
					break;
			case ODD_PARITY:
			case EVEN_PARITY:
			case MARK_PARITY:
					S2CON = 0xd8;
					break;
			case SPACE_PARITY:
					S2CON = 0xd0;
					break;
			}    
    
}


void uart_set_baud()
{
    DWORD baud;
    WORD temp;
    baud = LineCoding.dwDTERate;
    baud = REV4(baud);
    temp = (WORD)BR(MAIN_Fosc,baud);
    
		T2L = temp;
		T2H = temp >> 8;
    
}

void uart_polling()
{
    BYTE dat;
		
    if (DeviceState != DEVSTATE_CONFIGURED)
        return;
    if (!bUsbInBusy && (Uart2TxRptr != Uart2TxWptr))
    {
        while (Uart2TxRptr != Uart2TxWptr)
        {
            USB_SendData(&Uart2TxBuffer[Uart2TxRptr++],1);
						while (bUsbInBusy);
        }
    }


    if (!Uart2TxBusy && (Uart2RxRptr != Uart2RxWptr))
    {
        dat = Uart2RxBuffer[Uart2RxRptr++];
        Uart2TxBusy = 1;
        switch (LineCoding.bParityType)
        {
        case NONE_PARITY:
        case SPACE_PARITY:
            S2TB8 = 0;
            break;
        case ODD_PARITY:
            ACC = dat;
            S2TB8 = !P;
            break;
        case EVEN_PARITY:
            ACC = dat;
            S2TB8 = P;
            break;
        case MARK_PARITY:
            S2TB8 = 1;
            break;
        }
        S2BUF = dat;

    }
		
    if (bUsbOutReady)
    {
        if(OutNumber>0){
					memcpy(Uart2RxBuffer,UsbOutBuffer,OutNumber);
					Uart2RxRptr = 0;
					Uart2RxWptr = OutNumber;
					//USB_SendData(UsbOutBuffer, OutNumber?OutNumber:64);      //ԭ·, ڲHID
				}
				bUsbOutReady = 0;
				OutNumber = 0;
				usb_OUT_done();
    }
}
