#include "ai8051u.h"
#include "ai_usb_ex.h"
#include "string.h"

void initMouse();
void mouseRun();

extern BYTE bKeyCode;
extern BYTE bKeyDebounce;
extern BOOL fKeyOK;
BOOL mouseInBusy;
BYTE lastMouseCode;

sbit MOUSE34 = P3^4;
sbit MOUSE35 = P3^5;


#define Mouse_InterfaceNum 3
#define Mouse_EP 3
//ֻ
#define Mouse_IN_SIZE 3

char code MOUSECONFIGDESC[25] =
{
		0x09,                   //bLength(9);
    0x04,                   //bDescriptorType(Interface);
    Mouse_InterfaceNum,                   //bInterfaceNumber(1);
    0x00,                   //bAlternateSetting(0);
    0x01,                   //bNumEndpoints(1);
    0x03,                   //bInterfaceClass(HID);
    0x01,                   //bInterfaceSubClass(Boot);
    0x02,                   //bInterfaceProtocol(Mouse);
    0x00,                   //iInterface(0);

    0x09,                   //bLength(9);
    0x21,                   //bDescriptorType(HID);
    0x01,0x01,              //bcdHID(1.01);
    0x00,                   //bCountryCode(0);
    0x01,                   //bNumDescriptors(1);
    0x22,                   //bDescriptorType(HID Report);
    0x32,0x00,              //wDescriptorLength(50);

    0x07,                   //bLength(7);
    0x05,                   //bDescriptorType(Endpoint);
    0x80 | Mouse_EP,                   //bEndpointAddress(EndPoint2 as IN);
    0x03,                   //bmAttributes(Interrupt);
    Mouse_IN_SIZE,0x00,              //wMaxPacketSize(3);
    0x0a,                   //bInterval(10ms);
};
/*
Input Report:
0   Buttons (D0:LButton D1:RButton D2:MButton [D3:D7]:Pad)
1	X displacement (>0:right; <0:left)
2	Y displacement (>0:down; <0:up)
*/
char code MOUSEREPORTDESC[50] =
{
    0x05,0x01,              //USAGE_PAGE(Generic Desktop);
    0x09,0x02,              //USAGE(Mouse);
    0xa1,0x01,              //COLLECTION(Application);
    0x09,0x01,              //  USAGE(Pointer);
    0xa1,0x00,              //  COLLECTION(Physical);
    0x05,0x09,              //    USAGE_PAGE(Buttons);
    0x19,0x01,              //    USAGE_MINIMUM(1);
    0x29,0x03,              //    USAGE_MAXIMUM(3);
    0x15,0x00,              //    LOGICAL_MINIMUM(0);
    0x25,0x01,              //    LOGICAL_MAXIMUM(1);
    0x75,0x01,              //    REPORT_SIZE(1);
    0x95,0x03,              //    REPORT_COUNT(3);
    0x81,0x02,              //    INPUT(Data,Variable,Absolute);
    0x75,0x05,              //    REPORT_SIZE(5);
    0x95,0x01,              //    REPORT_COUNT(1);
    0x81,0x01,              //    INPUT(Constant);
    0x05,0x01,              //    USAGE_PAGE(Generic Desktop);
    0x09,0x30,              //    USAGE(X);
    0x09,0x31,              //    USAGE(Y);
    0x15,0x81,              //    LOGICAL_MINIMUM(-127);
    0x25,0x7f,              //    LOGICAL_MAXIMUM(127);
    0x75,0x08,              //    REPORT_SIZE(8);
    0x95,0x02,              //    REPORT_COUNT(2);
    0x81,0x06,              //    INPUT(Data, Variable, Relative);
    0xc0,                   //  END_COLLECTION;
    0xc0,                   //END_COLLECTION;
};
void mouseInFun()
{
    BYTE csr;

    usb_write_reg(INDEX, Mouse_EP);
    csr = usb_read_reg(INCSR1);
    if (csr & INSTSTL)
    {
        usb_write_reg(INCSR1, INCLRDT);
    }
    if (csr & INUNDRUN)
    {
        usb_write_reg(INCSR1, 0);
    }

    mouseInBusy = 0;
}
void initMouse(){
	  P3M0 = 0x00; P3M1 = 0x00; 
		mouseInBusy = 0;
		P26 = 0;
		lastMouseCode = 0x03;
		set_usb_ep_callback(Mouse_EP,64,mouseInFun,0,0);
		usb_add_interface(Mouse_InterfaceNum,MOUSECONFIGDESC,sizeof(MOUSECONFIGDESC),NULL);
		usb_add_hidDesc(Mouse_InterfaceNum,MOUSEREPORTDESC,sizeof(MOUSEREPORTDESC));
};


void mouseRun(){
		BYTE button[3];
		BYTE i;
		BYTE tempCode = (bKeyCode >> 2) & 0x03;	
		if (!mouseInBusy && fKeyOK & (tempCode != lastMouseCode))
		{
				lastMouseCode = tempCode;
				fKeyOK = 0;
				P26 = ~P26;
				button[0] = 0;
				button[1] = 0;
				button[2] = 0;

				switch (tempCode)
				{
						case 0x02:  button[0] = 0x01; button[1] = 0xCE; button[2] = 0xCE; break; //P34  Ͻƶ-50-50
						case 0x01:  button[0] = 0x02; button[1] = 0x64; button[2] = 0x64;break;//P35  Ҽ½ƶ100100
						case 0x00:  button[0] = 0x04; break;
				}
				
				//IE2 &= ~EUSB;
				EUSB = 0;
				mouseInBusy = 1;
				usb_write_reg(INDEX, Mouse_EP);
				for (i=0; i<3; i++)
				{
						usb_write_reg(FIFO0+Mouse_EP, button[i]);
				}
				usb_write_reg(INCSR1, INIPRDY);
				//IE2 |= EUSB;
				EUSB = 1;
		}
};