#include "ai8051u.h"
#include "ai_usb_ex.h"
#include "string.h"
#include "uart.h"
#include "CDC_ex_desc.h"

LINECODING LineCoding1;
LINECODING LineCoding2;
BYTE Interface;
BOOL Ep4InBusy;
BOOL Ep5InBusy;
BOOL Ep4OutBusy;
BOOL Ep5OutBusy;

void uart_settings(BYTE index)
{
		Interface = index;
    if (Interface == CDC1_FIRST_INTERFACE)
    {
        LineCoding1.bCharFormat = 0;
        LineCoding1.bDataBits = 8;
    }
		else if (Interface == CDC2_FIRST_INTERFACE)
    {
        LineCoding2.bCharFormat = 0;
        LineCoding2.bDataBits = 8;
    }

    uart_set_parity();
    uart_set_baud();
}



void usb_in_ep4()
{
    BYTE csr;

    usb_write_reg(INDEX, 4);
    csr = usb_read_reg(INCSR1);
    if (csr & INSTSTL)
    {
        usb_write_reg(INCSR1, INCLRDT);
    }
    if (csr & INUNDRUN)
    {
        usb_write_reg(INCSR1, 0);
    }
}
void usb_in_ep5()
{
    BYTE csr;

    usb_write_reg(INDEX, 5);
    csr = usb_read_reg(INCSR1);
    if (csr & INSTSTL)
    {
        usb_write_reg(INCSR1, INCLRDT);
    }
    if (csr & INUNDRUN)
    {
        usb_write_reg(INCSR1, 0);
    }

    Ep5InBusy = 0;
}
void usb_out_ep5()
{
    BYTE csr;
    BYTE cnt;

    usb_write_reg(INDEX, 5);
    csr = usb_read_reg(OUTCSR1);
    if (csr & OUTSTSTL)
    {
        usb_write_reg(OUTCSR1, OUTCLRDT);
    }
    if (csr & OUTOPRDY)
    {
        cnt = usb_read_reg(OUTCOUNT1);
        while (cnt--)
        {
            Uart2RxBuffer[Uart2RxWptr++] = usb_read_reg(FIFO5);
        }
        if ((BYTE)(Uart2RxWptr - Uart2RxRptr) >= (BYTE)(256 - EP5OUT_SIZE))
        {
            Ep5OutBusy = 1;
        }
        else
        {
            usb_write_reg(OUTCSR1, 0);
        }
    }
}


void initCDCEx(){
		//޸PID
		DEVICEDESC[10] = 0x0a;
		DEVICEDESC[11] = 0xFF;
		set_usb_uart_settings_callback(uart_settings);
		
		//CDC,ʹEP4 EP5
		usb_add_interface(CDC2_FIRST_INTERFACE,CONFIGDESC_CDC2_HEAD,sizeof(CONFIGDESC_CDC2_HEAD),&LineCoding2);
		usb_add_interface(CDC2_FIRST_INTERFACE+1,CONFIGDESC_CDC2_BODY,sizeof(CONFIGDESC_CDC2_BODY),NULL);
		set_usb_ep_callback(4,64,usb_in_ep4,0,0);
		set_usb_ep_callback(5,128,usb_in_ep5,248,usb_out_ep5);
}